fl

{
setup
    PropForth 4.0/4.0a compatible
    2011/2/2
}

: .long dup 10 rshift .word .word ;
: _sttop 2e _cv ;
: _stptr 5 _cv ;  
: st? ." ST: " _stptr COG@ 2+ dup _sttop < if _sttop swap - 0 do _sttop 2- i -  COG@ .long space loop else drop then cr ;
\ constant ( x -- ) skip blanks parse the next word and create a constant, allocate a long, 4 bytes
: constant lockdict create $C_a_doconl w, l, forthentry freedict ;
0 _crf W!

\-----------------------------------------------------------------------
\ denpatokei/monitor setup
\-----------------------------------------------------------------------
7a1200 constant 100ms
16e3600 constant 300ms
1e84800 constant 400ms
2dc6c00 constant 600ms
3567e00 constant 700ms
44aa200 constant 900ms

1F2	wconstant ina
1F8	wconstant ctra
1FA	wconstant frqa
1FC	wconstant phsa

4 wconstant _signal           \ signal-input from time-module
5 wconstant _LED              
6 wconstant _flag60

wvariable minute
wvariable P_minute
wvariable hour
wvariable P_hour
wvariable date
wvariable year
wvariable week
wvariable m_data 28 c, 14 c, 0a c, 00 c, 08 c, 04 c, 02 c, 01 c,
wvariable h_data 00 c, 00 c, 14 c, 0a c, 00 c, 08 c, 04 c, 02 c, 01 c,        00 c,
wvariable d_data1 00 c, 00 c, c8 c, 64 c, 00 c, 50 c, 28 c, 14 c, 0a c,       00 c,
wvariable d_data2 08 c, 04 c, 02 c, 01 c,
wvariable y_data 00 c, 50 c, 32 c, 14 c, 0a c, 08 c, 04 c, 02 c, 01 c,        00 c,
wvariable w_data 04 c, 02 c, 01 c,                                            00 c,

1 _signal lshift constant _signalm
1 _LED lshift constant _LEDm
1 _flag60 lshift constant _flag60m

\-----------------------------------------------------------------------
\ prop_clock setup
\-----------------------------------------------------------------------
wvariable total_1 1f w, 3c w, 5b w, 79 w, 98 w, b6 w, d5 w, f4 w, 112 w, 131 w, 14f w, 16e w,
wvariable total_2 1f w, 3b w, 5a w, 78 w, 97 w, b5 w, d4 w, f3 w, 111 w, 130 w, 14e w, 16d w, 

\ variable dT
wvariable second
wvariable prop_minute
wvariable prop_hour
wvariable prop_week
wvariable prop_date
wvariable prop_month
wvariable prop_day
wvariable prop_year
wvariable prev

7db prop_year W!         \ 2011
1 prop_date W!       \ Jan 5
0 prop_hour W!        \ 0 oclock
0 prop_minute W!      \ 0 minute
6 prop_week W!        \ Saturday
0 second W!

7 wconstant _flag55
1 _flag55 lshift constant _flag55m
13880 constant 1msec
\ 320   constant 10usec
clkfreq 899 + constant dT

\-----------------------------------------------------------------------
\ monitor setup
\-----------------------------------------------------------------------
wvariable signal 3a allot     \ signal buffer size 60byte
wvariable percent

\-----------------------------------------------------------------------
\ diff setup
\-----------------------------------------------------------------------
variable delay
clkfreq 5 u* constant 5sec
clkfreq a u* constant 10sec
