fl

{
monitor
    PropForth 4.0/4.0a compatible
    2011/2/2
}


\ ( n -- t/f )    n:pulse width(ticks)    true:valid pulse
: check dup dup 900ms < swap 700ms > and 
if 1
else dup dup 600ms < swap 400ms > and 
     if 1
     else dup dup 300ms < swap 100ms > and 
          if 1 else 0
thens
;                                         
                    
\ ( -- t/f)  true:_signalm bit is High  false:_signalm bit is Low     
: signal_status? ina COG@ _signalm and ;

\ ( -- n )  n:system counter's value
: cnt@ cnt COG@ ;

\ ( n -- t/f)  n:cnt  true:more than 900msec
: exceed_900ms? dup cnt@ swap - 900ms > ;

\ ( -- n )    n: ticks during Low or ticks over 900msec
: pulse_width?
begin
     signal_status?  
     if cnt@                            \ signal is High
        begin        
          signal_status?
          if exceed_900ms?              
             if cnt@ swap - 1 0 1       \ exceed 900msec 
             else 0 
             then
          else drop cnt@ 1 1            \ signal is Low
          then
        until
        if
          begin                         \ signal is Low     
               signal_status?
               if cnt@ swap - 1 1       \ from Low to High
               else exceed_900ms?       
                    if cnt@ swap - 1 1  \ exceed 900msec
                    else 0 
                    then
               then
          until
        then
     else cnt@                          \ signal is Low
          begin       
               signal_status?
               if drop 0 1              \ from Low to High
               else exceed_900ms?
                    if cnt@ swap - 1 1  \ exceed 900msec 
                    else 0  
                    then
               then
          until
     then
until
;

\ ( n -- t/f )  n:pulse ticks  true:valid pulse
: valid_pulse?
dup dup 100ms > swap 300ms < and   
if drop 1 else dup dup 400ms > swap 600ms < and   
   if drop 1 else dup 700ms > swap 900ms < and    
      if 1 else 0
thens
;    

\ ( -- n )  n:sum for signal_buf[0]-signal_buf[3c]
: signal_buf_sum 0 signal 3c 0 do C@++ rot + swap  loop drop ;

\ ( -- )   shift elements inside signal_buf
\ signal_buf[0]-->signal_buf[1],signal_buf[1]-->signal_buf[2] ... signal_buf[3a]-->signal_buf[3b]
: signal_buf_shift signal 3b 0 do dup 3a i - + C@++ swap C! loop drop ;
: check_signal_buffer signal 3c 0 do C@++ . loop drop ;

\ ( -- )  checking whether signal-pulse is valid(200msec or 500msec or 800msec)    fl 
: monitor
begin
     signal 3c 0 fill              \ siganal buffer clear
     begin       
          pulse_width? dup 900ms <
          if valid_pulse? signal C!
             signal_buf_sum                            
             64 u* 3c u/mod nip percent W!
             signal_buf_shift             
             0
          else drop 1    
          then
     until
\ signal is still Low or still High
     ff percent W!   
0
until     
;     
    