fl

{
prop_clock
    PropForth 4.0/4.0a compatible
    2011/1/30

}


: _flag55_out_l _flag55m _maskoutlo ;
: _flag55_out_h _flag55m _maskouthi ;

: tuki c" JanFebMarAprMayJunJulAugSepOctNovDec" ;
: youbi c" SUNMONTUEWEDTHUFRISAT" ;

\ waitcnt ( n1 n2 -- n1 ) \ wait until n1, add n2 to n1
: waitcnt _execasm2>1 1F1 _cnip ;
  
\ ( -- ) calculate month and day from prop_date
: convert_date
1 0              \ set month and day
c 0 do     
     prop_year W@ 4 u/mod drop 0=
     if total_1 else total_2 then
     2+ i 2 u* + W@ dup prop_date W@ >=
     if drop prop_date W@ swap - ibound seti
     else nip
          i b = if prop_year dup W@ 1+ swap W!
                   prop_date dup W@ 1+ swap W!
                   2drop 0 1
                then
          swap 1+ swap                
     then
loop
prop_day W! prop_month W!
;

: value_1+ dup W@ 1+ swap W! ;
\ update minute/hour/week/date
: uptime
prop_minute dup W@ 3b =       \ 59minute?
if 0 swap W!
   prop_hour dup W@ 17 =      \ 23oclock?
   if 0 swap W!
      prop_date value_1+ convert_date
      prop_week dup W@ 6 =    \ Sunday?
      if 0 swap W! convert_date
      else value_1+           
      then
   else value_1+
   then
else value_1+
then
;

: error_time
0 result W! clkfreq tmp L!
6 0 do dup tmp L@ >= if tmp L@ u/mod 30 + lcd_char 1 result W! 
                     else result W@ tmp L@ 1 = or if 30 lcd_char then
                     then
                     tmp L@ a u/ tmp L!
                     i 3 = if c" ." lcd_str then 
    loop
drop
;

: 2digit dup a < if c" 0" lcd_str then lcd_dec ;
\ (n -- ) display month name   n:month_number   
: month_name 1- 3 u* tuki 1+ + 3 bounds do i C@ lcd_char loop ;
\ (n -- ) display week name   n:week_number   
: week_name 3 u* youbi 1+ + 3 bounds do i C@ lcd_char loop ;     
: LCD_Display
1 1 lcd_pos prop_year W@ lcd_dec 1 lcd_blank \ prop_month W@ 2digit c" /" lcd_str prop_day W@ 2digit 1 lcd_blank
prop_month W@ month_name prop_day W@ 2digit 1 lcd_blank
c" ("  lcd_str prop_week W@ week_name c" )"  lcd_str
1 2 lcd_pos prop_hour W@ 2digit c" :" lcd_str prop_minute W@ 2digit c" :" lcd_str second W@ 2digit  
1 3 lcd_pos c" RadioStatus " lcd_str percent W@ dup ff = if drop c" LOST" 
                                                         else dup a < if 2 lcd_blank else dup 64 < 
                                                              if 1 lcd_blank then then lcd_dec c" %"  
                                                         then lcd_str
 1 4 lcd_pos delay L@ 0= if c" -----     " lcd_str
                        else 1 4 lcd_pos b lcd_blank 1 4 lcd_pos delay L@ dup 80000000 and if c" -" lcd_str invert 1+ then
                             error_time c" msec" lcd_str
                        then
\ 1 4 lcd_pos delay L@ 8 lcd_hex
;

: prop_clock
\ cnt COG@               \ A
lcd_init
10 4 lcd_setup      \ 16characters 4line
dira COG@ _flag55m or dira COG!       \ set _flag1m to output-port

0 second W!
convert_date
uptime

cnt COG@ dT + 1fb250 - 604ca0 -  
\ swap cnt COG@ swap - .      \ A'

begin
     LCD_Display  
     dT waitcnt
     second W@ 36 = if _flag55_out_h 1 delms _flag55_out_l then
     second W@ 1+ dup second W! 3c =    \ 60secnds?
     if 0 second W! uptime then
     0
until
;


