fl

{
MCP3204(12bit serial A/D converter)
    PropForth 4.0/4.0a compatible
    26/02/2011 10:29:14
}

{
: .long dup 10 rshift .word .word ;
: _sttop 2e _cv ;
: _stptr 5 _cv ;  
: st? ." ST: " _stptr COG@ 2+ dup _sttop < if _sttop swap - 0 do _sttop 2- i -  COG@ .long space loop else drop then cr ;
}
\ constant ( x -- ) skip blanks parse the next word and create a constant, allocate a long, 4 bytes
: constant lockdict create $C_a_doconl w, l, forthentry freedict ;


10 wconstant _cs         \ P16
11 wconstant _Di         \ P17  connect to MCP3204's Din
12 wconstant _Do         \ P18  connect to MCP3204's Dout
13 wconstant _clk        \ P19  

1 _cs lshift constant _csm 
1 _Di lshift constant _dim
1 _Do lshift constant _dom
1 _clk lshift constant _clkm

: _cs_out _cs pinout ;
: _di_out _Di pinout ;
: _do_in _Do pinin ;
: _clk_out _clk pinout ;

: _cs_l _csm _maskoutlo ;
: _cs_h _csm _maskouthi ;
: _di_l _dim _maskoutlo ;
: _di_h _dim _maskouthi ;
: _clk_l _clkm _maskoutlo ;
: _clk_h _clkm _maskouthi ;

\ single-end input for MCP3204
: get_single_a/d    \ (n -- )   n:channel [0 - 3]
_cs_l
18 +
5 0 do dup 1 4 i - lshift and 0> if _di_h else _di_l then
       _clk_l _clk_h
    loop
    drop
_clk_l _clk_h
   
0
d 0 do _clk_l _clk_h
       ina COG@ _dom and 0> if 1+ then
       1 lshift   
    loop     
    1 rshift
_cs_h
;

{
\ differencial input for MCP3204
n:differencial type 
                              0: CH0=IN+ CH1= IN-
                              1: CH0=IN- CH1= IN+
                              2: CH2=IN+ CH3= IN-
                              3: CH2=IN- CH3= IN+
}
: get_diff_a/d  \ (n -- ) 
5 0 do dup 1 4 i - lshift and 0> if _di_h else _di_l then
       _clk_l _clk_h
    loop
    drop
_clk_l _clk_h
   
0
d 0 do _clk_l _clk_h
       ina COG@ _dom and 0> if 1+ then
       1 lshift   
    loop     
    1 rshift
_cs_h
;
  

: disp_VR
_cs_out _di_out _clk_out
_cs_h _di_h _clk_h
_do_in 

a3500 waitT L!       
0 set_data 
c" 7seg_drive" 5 cogx

begin
0 get_single_a/d 
64 delms
3e7 u* fff u/ 

set_data drop

0 until
;

