{
2011/5/8

}

CON
    _clkmode = xtal1 + pll16x                           
    _xinfreq = 5_000_000

    MOSI = 0
    SCLK = 1
    CS   = 2
    MISO = 3
    
OBJ

' debug   :"FullDuplexSerialPlus"                      ''Used in this DEMO for Debug
mouse   :"Modify_Mouse"
kb      :"Modify_keyboard"
text    :"tv_text"

PUB main|data1, data2, i
{
    debug.start(31, 30, %0000, 115200)
    waitcnt(clkfreq*5 + cnt)
    debug.tx(0)
    debug.str(String("start"))
    debug.tx(13)
}
    dira[MISO]~~

    text.start(12)
    mouse.start(24, 25)
    kb.start(26,27)
    
    repeat
  '          debug.str(String("CS=L waiting"))
  '          debug.tx(13)
        waitpeq(|< CS, |< CS, 0) 
        waitpne(|< CS, |< CS, 0)
        data1 := shift_in
  '          debug.str(String("data="))
  '          debug.dec(data1)
        case data1
            5: ' debug.str(String("status"))
                shift_out(mouse.present + kb.present << 4)
              
            10: ' debug.str(String("mouse1"))
                shift_out(mouse.delta_z)
                shift_out(mouse.delta_y)
                shift_out(mouse.delta_x)
                shift_out(mouse.buttons)
                
            20: ' debug.str(String("keyboard"))
                shift_out(kb.getkey)
                                
            30: ' debug.str(String("TV string"))
                i := 0
                repeat
                   data1 := shift_in
      '                     debug.tx(13)
                   byte[@buffer+i] := data1
                 '  byte[@buffer][i] := data1
                   i++
                while data1 > 0
                text.str(@buffer)
                
            31: 'debug.str(String("TV dec"))
                data1 := shift_in
                text.dec(data1)

            32: 'debug.str(String("TV hex"))     
                data1 := shift_in
                data2 := shift_in
                text.hex(data2, data1)

            33: 'debug.str(String("TV bin"))     
                data1 := shift_in
                data2 := shift_in
                text.bin(data2, data1)
                
            34: 'debug.str(String("TV clear"))
                text.out(0)
            35: 'debug.str(String("TV home"))
                text.out(1) 
            36: 'debug.str(String("TV bs"))
                text.out(8)
            37: 'debug.str(String("TV tab")) 
                text.out(9)
            38: 'debug.str(String("TV x")) 
                text.out(10)
                data1 := shift_in
                text.out(data1) 
            39: 'debug.str(String("TV y")) 
                text.out(11)
                data1 := shift_in
                text.out(data1) 
            40: 'debug.str(String("TV color")) 
                text.out(12)
                data1 := shift_in
                text.out(data1)
            41: 'debug.str(String("TV return"))
                text.out(13)
                 
            42: 'debug.str(String("TV char"))
                data1 := shift_in            
                text.out(data1)
        
PRI shift_out(Value)          ' first MSB
    value <<= 24
    repeat 8
        waitpne(|< SCLK, |< SCLK, 0)
        outa[MISO] := (Value <-= 1) & 1
        waitpne(0, |< SCLK, 0)
                               
PRI shift_in:value            ' first MSB
    value := 0     
    repeat 8
        value <<= 1
        waitpne(|< SCLK, |< SCLK, 0)
        if ina[MOSI] ==1
            value := value + 1
        else
        waitpne(0, |< SCLK, 0)
               
DAT

buffer   byte    "PropForth_slave",0
    