fl

{
Demo for 2-wire_LCD driver
2010/4/16
propforth4.0a
}


: set_bar_graph
20 40
6 0 do              \ set 6 charcters
       8 0 do       \ set 8 lines for 1 character
              dup lcd_com     \ command for character to CG-RAM
              swap dup lcd_char swap    \ write data
              1+    
           loop
           f8 and   
       swap dup 1 rshift or swap
    loop
2drop
;
                
: demo
lcd_init
 10 4 lcd_setup      \ 16characters 4line

\  initilize Braightness and Contrast
cog W@ f0 and 50 <>
if
     c" 32 5 set_bright" 5 cogx        \ set LCD's backlight to duty=50% cycle time=5msec
     6 delms        \ wait
     cog W@ f0 and 50 <> if ." cog5 for brightness don't start" cr then
then
cog W@ f and 4 <>
if 
     c" 55 5 set_contrast" 4 cogx        \ set LCD's contrast to 80%
     6 delms        \ wait
     cog W@ f and 4 <> if ." cog4 for contrast don't start" then
then

\ display char-code [0x20 - 0x7f] & [0xa0 - 0xff]
20
line W@ 2 = if 7 0 else 3 0 then
do
        line W@ 2 = if i 3 = if 4 seti drop a0 then 
                       2 0 
                    else 4 0 
                    then
        do line W@ 4 = if j 1 = if i 2 = if 20 + then then then 
           1 i 1+ lcd_pos 10 0 do dup lcd_char 100 delms 1+ loop loop
    loop  
drop
lcd_clear 
\ display binary, hex, decimal
c" 0x1+0x6 = b" lcd_str 1 6 + 4 lcd_bin

1 2 lcd_pos
c" 0xACE+0xF=0x" lcd_str ace f + 4 lcd_hex
5 delsec

lcd_clear  1 cur_line W!
c" 0x12+0xe0=" lcd_str
12 e0 + lcd_dec c" (D)" lcd_str
LCD_cr

c" 0x0-0x12=" lcd_str
0 12 - lcd_dec c" (D)" lcd_str
5 delsec

set_bar_graph
lcd_clear
c" Bar Graph" lcd_str 
1    \ x-position 
char W@ 0
do 
  0 
  6 0 do dup lcd_char 1+ 64 delms swap dup 2 lcd_pos swap loop drop
  1+ dup 2 lcd_pos       \ increment x-position 
loop
drop

char W@ 2 lcd_pos
char W@
char W@ 0
do
  5
  6 0 do dup lcd_char 1- 64 delms swap dup 2 lcd_pos swap loop drop
  1- dup 2 lcd_pos 
loop
drop

lcd_clear
c" Demo Finished" lcd_str
1 2 lcd_pos
b3 c4 de b6 d8 b1 20 c6 b7 b5 b5 b 0 do lcd_char loop
;















: set_bar_graph2
40
8 0 do              \ set 8 charcters
      8 0 do        \ set 8 lines for 1 character
            dup lcd_com     \ command for character to CG-RAM 
            7 j - i <
            if 1f else 0 then lcd_char     \ write data
            1+ 
          loop
          f8 and
    loop
drop
;
      fl
variable tmp1
: demo2
lcd_init
\  initilize Braightness and Contrast
cog W@ f0 and 50 <>
if
     c" 32 5 set_bright" 5 cogx        \ set LCD's backlight to duty=50% cycle time=5msec
     6 delms        \ wait
     cog W@ f0 and 50 <> if ." cog5 for brightness don't start" cr then
then
cog W@ f and 4 <>
if 
     c" 55 5 set_contrast" 4 cogx        \ set LCD's contrast to 80%
     6 delms        \ wait
     cog W@ f and 4 <> if ." cog4 for contrast don't start" then
then

     cnt COG@
 10 4 lcd_setup      \ 16characters 4line
set_bar_graph2
lcd_clear
c" Wave" lcd_str
1 2 lcd_pos
1 tmp L! 1 tmp1 L!
0
100 0 do
     dup char W@ 0 do dup lcd_char dup 7 = tmp L@ 1 = and 
                                             if drop ff
                                             else dup ff = if drop 7 -1 tmp L!    
                                                            else dup 0 = if 1+ 1 tmp L!
                                                                         else tmp L@ + 
                                                                         then
                                                            then
                                             then
         loop
     drop
     1 2 lcd_pos
     dup 7 = tmp1 L@ 1 = and 
               if drop ff
               else dup ff = if drop 7 -1 tmp1 L!
                             else dup 0 = if 1+ 1 tmp1 L!
                                          else tmp1 L@ +
                                          then
                             then             
               then
              
loop
drop                           
     cnt COG@ swap - .                           
;                                        
